package activedirectory

import (
	csma "git.loafle.net/commons/service_matcher-go/activedirectory"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	"git.loafle.net/overflow/crawler-go"
)

type ActiveDirectoryHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *ActiveDirectoryHealthCrawler) Key() string {
	return "ACTIVEDIRECTORY_HEALTH"
}

func (c *ActiveDirectoryHealthCrawler) String() string {
	return "Active Directory Health Crawler"
}

func (c *ActiveDirectoryHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *ActiveDirectoryHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	ad := &ActiveDirectoryHealthCrawler{}
	ad.SetMatcher(csma.NewMatcher())
	return ad
}
