package cassandra

import (
	cnsmc "git.loafle.net/commons/service_matcher-go/cassandra"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type CassandraHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *CassandraHealthCrawler) Key() string {
	return "CASSANDRA_HEALTH"
}

func (c *CassandraHealthCrawler) String() string {
	return "Cassandra Health Crawler"
}

func (c *CassandraHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *CassandraHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &CassandraHealthCrawler{}
	c.SetMatcher(cnsmc.NewMatcher())
	return c
}
