package mongodb

import (
	cnsmm "git.loafle.net/commons/service_matcher-go/mongodb"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type MongoDBHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *MongoDBHealthCrawler) Key() string {
	return "MONGODB_HEALTH"
}

func (c *MongoDBHealthCrawler) String() string {
	return "MongoDB Health Crawler"
}

func (c *MongoDBHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *MongoDBHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &MongoDBHealthCrawler{}
	c.SetMatcher(cnsmm.NewMatcher())
	return c
}
