package oracle

import (
	cnsmo "git.loafle.net/commons/service_matcher-go/oracle"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type OracleHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *OracleHealthCrawler) Key() string {
	return "ORACLE_HEALTH"
}

func (c *OracleHealthCrawler) String() string {
	return "Oracle Health Crawler"
}

func (c *OracleHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *OracleHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &OracleHealthCrawler{}
	c.SetMatcher(cnsmo.NewMatcher())
	return c
}
