package sqlserver

import (
	cnsms "git.loafle.net/commons/service_matcher-go/sqlserver"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type SQLServerHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *SQLServerHealthCrawler) Key() string {
	return "SQLSERVER_HEALTH"
}

func (c *SQLServerHealthCrawler) String() string {
	return "SQL Server Health Crawler"
}

func (c *SQLServerHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *SQLServerHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &SQLServerHealthCrawler{}
	c.SetMatcher(cnsms.NewMatcher())
	return c
}
