package ssh

import (
	cnsms "git.loafle.net/commons/service_matcher-go/ssh"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type SSHHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *SSHHealthCrawler) Key() string {
	return "SSH_HEALTH"
}

func (c *SSHHealthCrawler) String() string {
	return "SSH Health Crawler"
}

func (c *SSHHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *SSHHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	result := make(map[string]string, 0)

	conn, cErr := c.GetConnection(config)
	defer conn.Close()

	if cErr != nil {
		result["Error"] = cErr.Error()
		return result, cErr
	}


	rss, err := c.CheckHealth1(config, conn, result)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &SSHHealthCrawler{}
	c.SetMatcher(cnsms.NewMatcher())
	return c
}
